#!/usr/bin/perl
##############################################################################
#
#  ETS -- Wolfenstein: Enemy Territory Statistics
#  (c) Vladi Shabanski <cade@bis.bg> 2003
#  http://soul.datamax.bg/~cade/away/ets
#
#  Developed for play.evrocom.net server ET community
#  http://play.evrocom.net
#
#  This software is distributed under GPL license, see COPYING for details.
#
#  $Id: ets.pl,v 1.38 2003/08/03 01:37:45 cade Exp $
#
##############################################################################
use Data::Dumper;
use strict;

###CONFIG#####################################################################

our $FLOOR = 50;

our $SCORE_FLOOR = 100;

my $html_header = "<html>
        <meta http-equiv='content-type' content='text/html; charset=iso-8859-1'>
        <title>Wolfenstein: Enemy Territory Statistics</title>
        <style>
        <!--
        BODY  { margin: 0px 0px 0px 0px; color: #fff;
                background-color: #111;
                background-image: url(etback.jpg);
                background-repeat: no-repeat;
                background-position top center;
                background-attachment: fixed; }
        TABLE { font-family: monospace; background-color: #888; white-space: pre; }
        TR.hh { border: solid 1px #aaa; background-color: #777; font-weight: bold; }
        TR.ff { border: solid 1px #aaa; background-color: #777; font-weight: bold; }
        TR.cc { border: solid 1px #aaa; background-color: #445; text-color: #aaa; }
        TR.r1 { border: solid 1px #aaa; background-color: #444; }
        TR.r2 { border: solid 1px #aaa; background-color: #555; }
        A     { font-family: monospace; color: #0ff; text-decoration: none; }
        A.t   { font-family: monospace; color: #0ff; text-decoration: none; display: block; }
        DIV.hitext { color: #ff0; font-weight: bold; }
        -->
        </style>
        <center>
        <p>
        <h1>Wolfenstein: Enemy Territory Statistics</h1>
        <h2>[ENV:ETS_SERVER]</h2>
        <small>This page is created at [TIME]</small>
        <p>
        |
        <a href=rank.html>rank tables (best players)</a> |
        <a href=games.html>last games</a> |
        <a href=score.html>scores</a> |
        <a href=kill.html>kills/deaths/ratio</a> |
        <a href=classide.html>sides/classes</a> |
        <br>
        |
        <a href=wep.html>weapons</a> |
        <a href=skills.html>skills</a> |
        <a href=uniforms.html>uniforms/disguise</a> |
        <a href=kpm.html>top kills per minute</a> |
        <a href=noise.html>noise</a> |
        <a href=waste.html>time waste</a> |
        <br>
        |
        <a href=p_axis.html>axis</a> |
        <a href=p_allies.html>allies</a> |
        <p>
        ";

my $html_footer = "<p>
       <small>
       Note: Limit is set to top $FLOOR entries (the rest are counted but not shown).<p>
       Thanks to all players at <a href=http://play.evrocom.net>http://play.evrocom.net</a>!<br>
       <a href=http://soul.datamax.bg/~cade/away/ets><b>ETS</b></a> by (c) <a href=mailto:cade\@bis.bg>&lt;cade\@bis.bg&gt;</a> 2003
       </small>
       </center>
       </html>";

my $html_motd = "<h2>Welcome to server statistics page for play.evrocom.net!</h2>";

###STATIC#####################################################################

my %CLASS = (
             0 => 'SOLDIER',
             1 => 'MEDIC',
             2 => 'ENGINEER',
             3 => 'FIELD_OPS',
             4 => 'COVERT_OPS',
            );
            
my %SIDE  = (
             0 => 'UNKNOWN',
             1 => 'AXIS',
             2 => 'ALLIES',
             3 => 'SPECTATORS',
            );            
my %WEAPON = (
             0 => 'KNIFE',
             1 => 'LUGER',
             2 => 'COLT',             #  8
             3 => 'MP40',             #  9
             4 => 'THOMPSON',         # 10
             5 => 'STEN',             # 11
             6 => 'FG42',             # 15
             7 => 'PANZERFAUST',
             8 => 'FLAMETHROWER',
             9 => 'GRENADE',
            10 => 'MORTAR',
            11 => 'DYNAMITE',         # 26
            12 => 'AIRSTRIKE',        # 28
            13 => 'ARTY',             # 30
            14 => 'SYRINGE',
            15 => 'SMOKECAN',
            16 => 'SATCHEL',
            17 => 'GRENADE_LAUNCHER', # 18
            18 => 'LANDMINE',         # 45
            19 => 'MOBILE_MG42',
            20 => 'GARAND',
            21 => 'KAR98'
            );
my %WEAPON_REV = reverse %WEAPON;            

my %SKILL = (
             0 => 'BATTLE SENSE',             
             1 => 'ENGINEERING   (ENGINEER)',             
             2 => 'FIRST AID     (MEDIC)',
             3 => 'SIGNALS       (FIELD OPS)',
             4 => 'LIGHT WEAPONS',
             5 => 'HEAVY WEAPONS (SOLDIER)',
             6 => 'COVERT OPS    (COVERT OPS)',
            );
my %SKILL_IMG = (
             0 => '<img src=bs.gif border=0>',
             1 => '<img src=en.gif border=0>',
             2 => '<img src=fa.gif border=0>',
             3 => '<img src=si.gif border=0>',
             4 => '<img src=lw.gif border=0>',
             5 => '<img src=hw.gif border=0>',
             6 => '<img src=co.gif border=0>',
            );
            
# thanx, furiozo :)
my %COLOR = (
            '1' => 'f70400',
            '2' => '02f702',
            '3' => 'fdf900',
            '4' => '0006f8',
            '5' => '00f6f3',
            '6' => 'f407f5',
            '7' => 'f9f9f9',
            '8' => 'ff7b06',
            '9' => '7c7d81',
            '0' => '000100',
            'q' => 'f70303',
            ')' => 'f70303',
            'w' => 'f4f6f1',
            'e' => '8100fd',
            'r' => '00f904',
            't' => '0005f4',
            'y' => '7b7d7a',
            'u' => '00faf6',
            'i' => 'fb0033',
            'o' => 'eff174',
            'p' => '060702',
            'a' => 'fd9534',
            's' => 'fbf904',
            'd' => '007dfe',
            'f' => '3795c8',
            '&' => '3795c8',
            'g' => 'c2fcc9',
            'h' => '066432',
            '(' => '066432',
            'j' => 'ad1c17',
            'k' => '9b3107',
            'l' => 'cf9834',
            ';' => 'c0bfc7',
            'z' => 'bcbdc2',
            'x' => 'f98000',
            'c' => '7b0484',
            'v' => 'f900f9',
            'b' => '037d7e',
            'n' => 'faf9c0',
            'm' => '9b9935',
            ',' => 'cf9a3a',
            '.' => 'f7f8b6',
            '/' => 'fbfc7c',
            '-' => '98972d',
            '=' => '7f7f00',
            '\\' => '007f03',
            '[' => 'bec0bb',
            ']' => '7f7c0b',
            '\'' => 'c5f9c8',
            '*' => 'ae181a',
            );

###MAIN#######################################################################

die "usage: $0 log-file html-output-dir\n" unless @ARGV == 2;

my $log_file = shift;
my $html_dir = shift;

my %name_map = split /[=\n]+/, `cat $ENV{ETS_NAME_MAP}`
  if -e $ENV{ETS_NAME_MAP};

my %kil;
my %ded;
my %kil2;
my %ded2;

my %wep;  # wepon usage by weapon -> count
my %wep2; # weapon usage by players/clans -> weapon
my %wep3; # weapon usage by weapons -> player/clan

my %nam;
my %nam_color;

my %unif_taken; # uniforms taken
my %unif_lost; # uniforms lost

my %noise; # noise in words :)

my %class_last; # last classes per player
my %class; # classes per player

my %side_last; # last side per player
my %side; # side per player

my %global_class;
my %global_side;

my %classes;
my %sides;

my %client; # clients info

my $href = 0;
my %href;

my $minute; # used for top kills per minute
my %kpm_temp;
my %kpm;

my %conn_time;  # connect time
my %time_waste; # time "wasted" :)

my %game;  # game statistics
my @games; # all games

my %player; # stats from weapon stats, same as in @games

my %weapons; # stats total
my %skills;  # skills total

my %members; # clan members

#-----------------------------------------------------------------------------

setpriority( 0, 0, 19 );

my $time_base = 0;
my $local_time = 0;
my $last_local_time = 0;
my $time = 0;

my $last_game_time;
my %last_server;
my $exit = 0;

print STDERR "processing log file: $log_file\n";

open( my $i, $log_file ) or die "$0: cannot open log file: $log_file\n";
while(<$i>)
  {
  next if /^[\s\r\n]*$/;
  s/<world>/*WORLD*/gi;
  s/^\s*(\d+):(\d+)\s*//; # get time
  $local_time = $1 * 60 + $2;
  if( $last_local_time > $local_time )
    {
    $time_base = $time_base + $last_local_time;
    }
  $last_local_time = $local_time;
  $time_base = $1 if /^TIME:(\d+)/; # get time base
  $time = $time_base + $local_time;
  $minute = $time - $time % 60;
  my $time_str = scalar localtime( $time );
  $time_str =~ s/  / 0/;

#print STDERR "$time_str ($time) [$time_base:$local_time] $_";

  if( /^ClientConnect: (\d+)/i )
    {
    #print STDERR "c: $1\n";
    next if exists $conn_time{ $1 };
    $conn_time{ $1 } = $time;
    next;
    }
  if( /^ClientDisconnect: (\d+)/i )
    {
    next unless exists $conn_time{ $1 };
    my $wasted = int( $time - $conn_time{ $1 } );
    delete $conn_time{ $1 };
    my $name = $client{ $1 }{ 'n' };
    #print STDERR "d: $1 ($name) $wasted\n";
    next if $name eq ''; # anonymous
    $time_waste{ $name } += $wasted;
    $time_waste{ get_clan( $name ) } += $wasted;
    next;
    }
  if( /^ShutdownGame:/ )
    {
    for my $k ( keys %conn_time )
      {
      my $wasted = int( $time - $conn_time{ $k } );
      my $name = $client{ $k }{ 'n' };
      next if $name eq '';
      $time_waste{ $name } += $wasted;
      $time_waste{ get_clan( $name ) } += $wasted;
      #print STDERR "d: $k ($name) $wasted\n";
      }
    %conn_time = ();  
    # next; # nadolu ima oshte edin handler za shutdown game
    }
  if( /^ClientUserinfoChanged: (\d+) (.+)/i )
    {
    # n\xwayBG\t\2\c\4\r\0\m\0000000\s\0000000\dn\chromosome\dr\0\w\10\lw\10\sw\41\mu\0\ref\0
    my $id = $1;
    my $data = $2;
    $client{ $id } = { split /\\/, $data };
    
    my ( $name, $color_name );
    $name = $color_name = $client{ $id }{ 'n' };
    $name =~ s/\^.//g; # clear colors etc.
    
    $client{ $1 }{ 'n' } = $name = $name_map{ $name }
        if( $name_map{ $name } );
    $nam{ $name }++;
    $nam{ get_clan( $name ) }++;
    
    $nam_color{ $name } = $color_name if $name ne $color_name;
    
    $client{ $id }{ 'n' } = $name;
    $client{ $id }{ 'dn' } =~ s/\^.//g; # clear colors etc.

    my $dn = $client{ $id }{ 'dn' };
    my $class = $CLASS{ $client{ $id }{ 'c' } };
    my $side = $SIDE{ $client{ $id }{ 't' } };
    if( $dn )
      {
      $unif_taken{ $name }++;
      $unif_lost{ $dn }++;
      };
    if( $class_last{ $name } ne $class )
      {
      $class{ $name }{ $class }++;
      $class{ get_clan( $name ) }{ $class }++;
      $class_last{ $name } = $class;
      $global_class{ $class }++;
      $classes{ $class }{ $name }++;
      $classes{ $class }{ get_clan( $name ) }++;
      }
    if( $side_last{ $name } ne $side )
      {
      $side{ $name }{ $side }++;
      $side{ get_clan( $name ) }{ $side }++;
      $side_last{ $name } = $side;
      $global_side{ $side }++;
      $sides{ $side }{ $name }++;
      $sides{ $side }{ get_clan( $name ) }++;
      }
    next;
    }
  s/\^.//g; # clear colors etc. this is after ClientUserinfoChanged to preserve original names
  if( /WeaponStats:\s*(.+)$/ )
    {
    my $data = parse_weaponstats( $1, $last_game_time );
    $game{ $data->{ 'PLAYER' } } = $data if $data;
    next;
    }
  if( /^InitGame:\s*(.*)$/ )
    {
    $exit = 0;
    $last_game_time = $time;
    %last_server = split /\\/, "\\$1";
    next;
    }
  if( /Exit:/ )
    {
    $exit = 1;
    }
  if( /^ShutdownGame/ and $exit )
    {
    my @players = keys %game;
    my $pc = scalar @players;
    if( $pc > 0 )
      {
      push @games, { 'STATS' => { %game },
                     'TIME' => $time, 
                     'PLAYERS' => $pc,
                     'MAP' => $last_server{ 'mapname' },
                      };
      }                
    %game = ();
    next;
    }  
  if( /Kill: (\d+) (\d+) (\d+): (.+) killed (.+) by MOD_([A-Z_0-9]+)/i )
    {
    my $k = $name_map{ $4 } || $4;
    my $d = $name_map{ $5 } || $5;
    my $w = $6;
    
    $kpm_temp{ $k }{ $minute }++;
    $kpm_temp{ get_clan( $k ) }{ $minute }++;
    
    # kills
    $kil{ $k }++;
    $kil{ get_clan( $k ) }++;
    $kil2{ $k }{ $d }++;
    $kil2{ get_clan( $k ) }{ get_clan( $d ) }++;
    
    # deaths
    $ded{ $d }++;
    $ded{ get_clan( $d ) }++;
    $ded2{ $d }{ $k }++;
    $ded2{ get_clan( $d ) }{ get_clan( $k ) }++;
    
    # weapon usage
    $wep{ $w }++;
    $wep2{ $k }{ $w }++;
    $wep2{ get_clan( $k ) }{ $w }++;
    $wep3{ $w }{ $k }++;
    $wep3{ $w }{ get_clan( $k ) }++;
    
    # get names...
    $nam{ $k }++;
    $nam{ $d }++;
    $nam{ get_clan( $k ) }++;
    $nam{ get_clan( $d ) }++;

    next;
    }
  if( /^say(team)?: ([^:]+): (.+)/i )
    {
    my $p = $2;
    my $cnt = $3 =~ /\S+/g;
    $noise{ $p } += $cnt;
    $noise{ get_clan( $p ) } += $cnt;
    next;
    }
  #if( /^score: +(\d+) +ping: +(\d+) +client: (\d+) (.+)/ )
  #  {
  #  next;
  #  }
  #if( /?? end/start of game ??/ )
  #  {
  #  %class_last = ();
  #  %side_last = ();
  #  next;
  #  }  
  }
close($i);

print STDERR "done (end virtual time is $time)\n";

#-----------------------------------------------------------------------------

print STDERR "processing data...\n";

$nam_color{ 'AXIS' } = "^1AXIS";
$nam_color{ 'ALLIES' } = "^4ALLIES";
$nam_color{ 'SPECTATORS' } = "^2SPECTATORS";

# fix names links
for my $k ( keys %nam )
  {
  my $k2 = $k;
  $k2 =~ s/[^!a-z0-9\-\_]/_/gi;
  $href{ $k } = lc $k2;
  
  my $c = get_clan( $k );
  $members{ $c }{ $k }++;
  }

# gather clan stats
for my $p ( keys %player )
  {
  my $c = get_clan( $p );
  $player{ $c }{ 'SCORE_TMP' } = []
      unless $player{ $c }{ 'SCORE_TMP' };
  push @{ $player{ $c }{ 'SCORE_TMP' } }, @{ $player{ $p }{ 'SCORE_TMP' } };
  for my $sc ( 0..6 )
    {
    $player{ $c }{ 'SKILL_TMP' }{ $sc } = []
        unless $player{ $c }{ 'SKILL_TMP' }{ $sc };
    push @{ $player{ $c }{ 'SKILL_TMP' }{ $sc } }, @{ $player{ $p }{ 'SKILL_TMP' }{ $sc } }
        if $player{ $p }{ 'SKILL_TMP' }{ $sc };
    }
  }

# calc player stats
for my $p ( keys %player )
  {
  my $v = $player{ $p }{ 'SCORE_TMP' };
  $player{ $p }{ 'SCORE_TMP' } = undef;
  my $sum = 0;
  $sum += $_ for @$v;
  # print "$p --> $sum, @$v, sum=$sum, med: " . $$v[@$v/2] . "\n";
  if( $sum > 0 )
    {
    @$v = grep { $_ > $SCORE_FLOOR } sort { $a <=> $b } @$v;
    $player{ $p }{ 'MEDIAN_SCORE' } = $$v[@$v/2];
    $player{ $p }{ 'AVERAGE_SCORE' } = int( $sum / @$v ) if @$v > 0;
    $player{ $p }{ 'TOTAL_SCORE' } = $sum;
    $player{ $p }{ 'ROUNDS' } = @$v;
    }
  for my $sc ( 0..6 )
    {
    my $v = $player{ $p }{ 'SKILL_TMP' }{ $sc };
    $player{ $p }{ 'SKILL_TMP' }{ $sc } = undef;
    my $sum = 0;
    $sum += $_ for @$v;
    if( $sum > 0 )
      {
      @$v = grep { $_ > 0 } sort { $a <=> $b } @$v;
      $player{ $p }{ 'MEDIAN_SKILL' }{ $sc } = $$v[@$v/2];
      $player{ $p }{ 'AVERAGE_SKILL' }{ $sc } = int( $sum / @$v ) if @$v > 0;
      $player{ $p }{ 'SKILL' }{ $sc } = $sum;
      }
    }
  }

# remove MEDIAN XP below threshold users
#for my $p ( keys %player )
#  {
#  delete $player{ $p } if $player{ $p }{ 'MEDIAN_SCORE' } < $SCORE_FLOOR;
#  }

while( my ( $k, $v ) = each %kpm_temp )
  {
  my ( $max_k, $max_v ) = hash_max( $v );
  # $k = sprintf "%s  %s", scalar localtime( $max_k ), color_name( $k );
  $kpm{ $k } = $max_v;
  }

print STDERR "done\n";

#-----------------------------------------------------------------------------

my @games_text;

push @games_text, [ 'HEAD', '[>5%]#', '[20%]Map', '[20%]Finish Time', '[55%]Players' ];
@games = reverse @games;
my $gc = 0; # game counter
for my $gr ( @games )
  {
  my $ti = $gr->{ 'TIME' };
  my $ma = $gr->{ 'MAP' };
  my $tm = localtime( $ti );
  my $pl = sprintf "%02d", $gr->{ 'PLAYERS' };
  next unless $pl > 0;
  my $ww = $pl * 10;
  push @games_text, [ '', '(ROW)', $ma, "<a class=t href=game_$ti.html>$tm</a>", "$pl <img src=wp.gif height=10 width=$ww>" ];
  html_save( "game_$ti", "<h2>game at $tm on $ma map, $pl players</h2>",
                         single_game_stats( $gr, TYPE => 'SKILLS', SIDE => 'ALLIES' ),
                         single_game_stats( $gr, TYPE => 'SKILLS', SIDE => 'AXIS' ),
                         single_game_stats( $gr, TYPE => 'SHOTS', SIDE => 'ALLIES' ),
                         single_game_stats( $gr, TYPE => 'SHOTS', SIDE => 'AXIS' ),
                         single_game_stats( $gr, TYPE => 'DAMAGE', SIDE => 'ALLIES' ),
                         single_game_stats( $gr, TYPE => 'DAMAGE', SIDE => 'AXIS' ),
                         single_game_stats( $gr, TYPE => 'DETAILS' ) );
  $gc++;
  }

html_save( 'index', $html_motd );
html_save( 'games', $html_motd, "<p><h2>Last games: (approx. last 24 hours)</h2><p>", 
                                html_table( [ grep /\S/, @games_text[0..50] ] ), 
                                "<p><a href=games_all.html>show all $gc games (long!)</a>" );
html_save( 'games_all',         $html_motd . "<p><h2>All $gc games</h2><p>" . html_table( \@games_text ) );

for my $c ( '', 4..6 )
  {
  html_save( "kill$c", "sort by: 
                          <a href=kill4.html>Kills</a>
                        | <a href=kill5.html>Deaths</a>
                        | <a href=kill6.html>K:D Ratio</a>",
                        "<p><h2>kills/deaths/ratio</h2><p>",
                        mod_player_clan_stats( CLAN => 1, FLOOR => $FLOOR, SORT => $c || 4 ), 
                        mod_player_clan_stats( CLAN => 0, FLOOR => $FLOOR, SORT => $c || 4 ) );
  }
  
for my $k ( keys %sides )
  {
  $href{ $k } = lc $k;
  html_save( 'p_' . $href{$k}, mod_hash_stats( "$k (totals per clan)", $sides{ $k }, CLAN => 1 ),
                               mod_hash_stats( "$k", $sides{ $k } ) );
  }

for my $k ( keys %nam )
  {
  my $text;
  my $clan = 0;
  $clan = 1 if $k =~ /^!/;
  $text .= mod_clan_members( "clan members of " . color_name( $k ), $k ) if $clan;
  $text .= mod_hash_stats( "sides played by " . color_name( $k ), $side{ $k } );
  $text .= mod_skills_stats( "skills statistics for " . color_name( $k ), $k );
  $text .= mod_weapons_stats( "weapons statistics for " . color_name( $k ), $k );
  $text .= mod_kill_killed( "public relations for " . color_name( $k ), $k );
  
  html_save( 'p_' . $href{$k}, $text );
  }

html_save( 'noise',    mod_hash_stats( "noise in words by clan", \%noise, CLAN => 1 ),
                       mod_hash_stats( "noise in words by player", \%noise ) );

html_save( 'uniforms', mod_hash_stats( "uniforms taken", \%unif_taken ),
                       mod_hash_stats( "uniforms lost", \%unif_lost ) );

html_save( 'kpm',      mod_hash_stats( "top kills per minute by clan",   \%kpm, NOP => 1, CLAN => 1 ),
                       mod_hash_stats( "top kills per minute by player", \%kpm, NOP => 1 ) );

html_save( 'waste',    mod_hash_stats( "time wasted by clan",   \%time_waste, TIMEFMT => 1, CLAN => 1, HEAD => "#,Player,Time,Percentage" ),
                       mod_hash_stats( "time wasted by player", \%time_waste, TIMEFMT => 1,  HEAD => "#,Clan,Time,Percentage" ) );

html_save( 'classide', mod_hash_stats( "sides played", \%global_side ),
                       mod_hash_stats( "classes played", \%global_class ) );

for my $c ( '', 3..10 )
  {
  html_save( "rank$c",   "best: 
                            <a href=rank3.html>XP</a>
                          | <a href=rank4.html>battle sense</a>
                          | <a href=rank5.html>engineer</a>
                          | <a href=rank6.html>medic</a>
                          | <a href=rank7.html>field ops</a>
                          | <a href=rank8.html>light weapons</a>
                          | <a href=rank9.html>heavy weapons (soldiers)</a>
                          | <a href=rank10.html>covert ops</a>",
                        mod_ranks( "ranks", SORT => $c || 3 ) );
  }

for my $c ( '', 3..9 )
  {
  html_save( "wep$c",   "sort by: 
                            <a href=wep3.html>Shots</a>
                          | <a href=wep4.html>Hits</a>
                          | <a href=wep5.html>Head</a>
                          | <a href=wep6.html>Kills</a>
                          | <a href=wep7.html>Deaths</a>
                          | <a href=wep8.html>Acc.%</a>
                          | <a href=wep9.html>HeadAcc.%</a>",
                        mod_weapons_totals( "weapons totals", SORT => $c || 6 ) );
  }

for my $w ( keys %WEAPON )
  {
  my $ww = lc $WEAPON{ $w };
  for my $c ( '', 3..9 )
    {
    html_save( "w_$ww$c", "sort by: 
                            <a href=w_${ww}3.html>Shots</a>
                          | <a href=w_${ww}4.html>Hits</a>
                          | <a href=w_${ww}5.html>Head</a>
                          | <a href=w_${ww}6.html>Kills</a>
                          | <a href=w_${ww}7.html>Deaths</a>
                          | <a href=w_${ww}8.html>Acc.%</a>
                          | <a href=w_${ww}9.html>HeadAcc.%</a>",
                          mod_weapons_usage( "usage of weapon $WEAPON{$w} by clan", $w, CLAN => 1, SORT => $c || 6),
                          mod_weapons_usage( "usage of weapon $WEAPON{$w} by player", $w, CLAN => 0, SORT => $c || 6 ) );
    }                    
  }                  
html_save( 'skills', mod_skills_totals( "skills totals" ) );
for my $s ( keys %SKILL )
  {
  my $sw = lc $SKILL{ $s };
  $sw = $1 if $sw =~ /^([A-Z]+)/i;
  html_save( "s_$sw", mod_skills_usage( "usage of skill $SKILL{$s} by clan", $s, CLAN => 1 ),
                      mod_skills_usage( "usage of skill $SKILL{$s} by player", $s, CLAN => 0 ) );
  }

for my $c ( '', 3..9 )
  {
  html_save( "score$c", 
                        #($c == 3 or ! $c) ? "<h2>median score is the primary player rank criterion</h2>" : '',
                        "sort by: 
                            <a href=score3.html>Median</a>
                          | <a href=score4.html>Rounds</a>
                          | <a href=score5.html>Average</a>
                          | <a href=score6.html>Total</a>",
                        mod_score_stats( "scores by clan", CLAN => 1, SORT => $c || 3 ),
                        mod_score_stats( "scores by player", CLAN => 0, SORT => $c || 3 ) );
  }
  
##############################################################################

sub mod_ranks
{
  my $title = shift;
  my %opt = @_;
  my $clan = $opt{ 'CLAN' };
  
  my @data;

  my @p = keys %nam;
  @p = grep /^!/, @p if $clan;
  @p = grep ! /^!/, @p if ! $clan;
  
  push @data, [ 'HEAD', "[>5%]#", "[23%]Player/Clan", "[>6%]XP", map( { '[>7%]' . $SKILL_IMG{ $_ } } ( 0..6 ) ) ];
  
  my $r = 0;
  for my $p ( @p )
    {
    next if $player{ $p }{ 'MEDIAN_SCORE' } < $SCORE_FLOOR;
    my $pc = color_name( $p );
    
    push @data, [ '', "(ROW)", "<a class=t href=p_$href{$p}.html>$pc</a>", 
                               $player{ $p }{ 'MEDIAN_SCORE' },
                               map( { $player{ $p }{ 'MEDIAN_SKILL' }{ $_ } } ( 0..6 ) )
                               ];
    }
  
  return "<h2>$title</h2>" . html_table( \@data, SORT => $opt{ SORT } );
}

##############################################################################

sub mod_clan_members
{
  my $title = shift;
  my %opt = @_;
  my $clan = shift;
  
  my @data;

  my @pl = keys %{ $members{ $clan } };
  
  push @data, [ 'HEAD', "[25%]Player", "[25%]Player", "[25%]Player", "[25%]Player" ];

  while( @pl )
    {
    my @r;
    for( 1..4 )
      {
      my $p = shift @pl;
      my $pc = color_name( $p );
      push @r, "<a class=t href=p_$href{$p}.html>$pc</a>";
      }
    push @data, [ '', @r ];
    }
  
  return "<h2>$title</h2>" . html_table( \@data );
}

##############################################################################

sub mod_score_stats
{
  my $title = shift;
  my %opt = @_;
  my $clan = $opt{ 'CLAN' };
  
  my @data;

  my @p = keys %nam;
  @p = grep /^!/, @p if $clan;
  @p = grep ! /^!/, @p if ! $clan;
  
  push @data, [ 'HEAD', "[>5%]#", "[23%]Player/Clan", "[>6%]Median", "[>6%]Rounds", "[>6%]Average", "[>6%]Total", "[>6%]Total%" ];
  
  my $sum;
  $sum += $player{ $_ }{ 'TOTAL_SCORE' } for @p;
  
  my $r = 0;
  for my $p ( @p )
    {
    next if $player{ $p }{ 'MEDIAN_SCORE' } < $SCORE_FLOOR;
    my $pc = color_name( $p );
    my $sump = $sum > 0 ? ( 100 * $player{ $p }{ 'TOTAL_SCORE' } ) / $sum : 0;
    push @data, [ '', "(ROW)", "<a class=t href=p_$href{$p}.html>$pc</a>", 
                               $player{ $p }{ 'MEDIAN_SCORE' }, 
                               $player{ $p }{ 'ROUNDS' }, 
                               $player{ $p }{ 'AVERAGE_SCORE' },
                               $player{ $p }{ 'TOTAL_SCORE' },
                               "$sump/p"
                               ];
    }

  push @data, [ 'FOOT', "", "Total:", "", "(SUM)/i", "", "(SUM)/i", '' ];
  
  return "<h2>$title</h2>" . html_table( \@data, SORT => $opt{ SORT } );
}

sub mod_player_clan_stats
{
  my %opt = @_;
  my $clan = $opt{ 'CLAN' };

  my @data;

  my $text;
  
  $text .= "<p>";
  $text .= $clan ? "<h2>Clans</h2>" : "<h2>Players</h2>";

  push @data, [ 'HEAD', "[>5%]#", "[15%]Clan", "[30%]Player", "[>10%]Kills", "[>10%]Deaths", "[>10%]K/D", "[>20%]Preferred Weapon" ];
  if( $clan )
    {
    $data[-1][2] = "[15%]";
    $data[-1][3] = "[30%]Clan";
    }
  
  my @p = keys %nam;
  
  for my $p ( @p )
    {
    next if $clan and $p !~ /^!/;
    next if !$clan and $p =~ /^!/;
    next if $player{ $p }{ 'MEDIAN_SCORE' } < $SCORE_FLOOR;

    my $k = $kil{ $p } || 0;
    my $d = $ded{ $p } || 0;
    my $r = $d > 0 ? sprintf "%.2f", $k / $d : 'n/a'; #'

    my $c = get_clan( $p );

    my $target1 = $href{ $c };
    my $target2 = $href{ $p };

    $p =~ s/>/&gt;/g;
    $p =~ s/</&lt;/g;

    my $w;
    ( $w, undef ) = hash_max( $wep2{ $p } );
    $w ||= 'n/a';

    my $class = tr_class();
    $p = color_name( $p );
    $c = color_name( $c );
    push @data, [ '', '(ROW)', "<a class=t href=p_$target1.html>$c</a>",
                               "<a class=t href=p_$target2.html>$p</a>",
                               $k, $d, $r,
                               "<a class=t href=wep.html>$w</a>" ];
    }
  push @data, [ 'FOOT', '', '', 'Totals:', '(SUM)', '(SUM)', '', '' ];
  $text .= html_table( \@data, SORT => $opt{ 'SORT' }, FLOOR => $opt{ 'FLOOR' } );
  $text .= "\n\n\n\n";
  return $text;
}

##############################################################################

sub single_game_stats
{
  my $gr = shift; # game hash reference
  my %opt = @_;
  
  my $side = $opt{ 'SIDE' };
  my $type = $opt{ 'TYPE' };
  
  my $game = $gr->{ 'STATS' };
  
  my $text;
  
  #$text .= Dumper( $gr );
  #$text = "<pre>$text</pre>";
  
  my @data_w;
  my @data_d;
  my @data_s;

  push @data_w, [ 'HEAD', '[>1%]#', '[30%]Player', '[1%]Side', '[>]Shots', '[>]Hits', '[>]Head', '[>]Kills', '[>]Deaths', '[>]Acc.%', '[>]HeadAcc.%', ];
  push @data_d, [ 'HEAD', '[>1%]#', '[30%]Player', '[1%]Side', '[>]Damage Given', '[>]Damage Received', '[>]Team Damage', ];
  push @data_s, [ 'HEAD', '[>1%]#', '[30%]Player', '[1%]Side', map( { '[>7%]' . $SKILL_IMG{ $_ } } ( 0..6 ) ), '[>12%]SCORE' ];

  my @p = keys %$game;
  @p = grep { $game->{ $_ }{ 'SIDE' } eq 'AXIS' } @p if $side eq 'AXIS';
  @p = grep { $game->{ $_ }{ 'SIDE' } eq 'ALLIES' } @p if $side eq 'ALLIES';
  #@p = sort { $game->{ $a }{ 'SIDE' } cmp $game->{ $b }{ 'SIDE' } } @p;
  @p = sort { $game->{ $b }{ 'SCORE' } <=> $game->{ $a }{ 'SCORE' } } @p;
  
  for my $p ( @p )
    {
    my $v = $game->{ $p };
    my $wt = $v->{ 'WEAPONS_TOTALS' };
    my $pc = color_name( $p );
    my $s = lc $v->{ 'SIDE' };
    my $sc = color_name( $v->{ 'SIDE' } );
    push @data_w, [ '', '(ROW)',
                "[<]<a class=t href=p_$href{$p}.html>$pc</a>", 
                "<a class=t href=p_$s.html>$sc</a>",
                $wt->{ 'S' },
                $wt->{ 'H' },
                $wt->{ 'E' },
                $wt->{ 'K' },
                $wt->{ 'D' },
                $wt->{ 'HA' } . '/p',
                $wt->{ 'EA' } . '/p',
                ];

    if( $type eq 'DETAILS' )
      {
      for my $w ( sort keys %{ $v->{ 'WEAPONS' } } )
        {
        $wt = $v->{ 'WEAPONS' }{ $w };
        push @data_w, [ 'COMT', '(ROW)',
                    '[>]' . $WEAPON{ $w },
                    "<a class=t href=p_$s.html>$sc</a>",
                    $wt->{ 'S' },
                    $wt->{ 'H' },
                    $wt->{ 'E' },
                    $wt->{ 'K' },
                    $wt->{ 'D' },
                    $wt->{ 'HA' } . '/p',
                    $wt->{ 'EA' } . '/p',
                    ];
        }
      }          
    push @data_d, [ '', '(ROW)',
                "<a class=t href=p_$href{$p}.html>$pc</a>", 
                color_name( $v->{ 'SIDE' } ),
                $v->{ 'DAMAGE' }{ 'SENT' },
                $v->{ 'DAMAGE' }{ 'RECV' },
                $v->{ 'DAMAGE' }{ 'TEAM' },
                ];
    my @ss;
    push @ss, $v->{ 'SKILL' }{ $_ } for ( 0..6 );
    push @data_s, [ '', '(ROW)',
                "<a class=t href=p_$href{$p}.html>$pc</a>", 
                color_name( $v->{ 'SIDE' } ),
                @ss,
                $v->{ 'SCORE' }
                ];
    }

  push @data_w, [ 'FOOT', '', '', 'Total:', '(SUM)', '(SUM)', '(SUM)', '(SUM)', '(SUM)', '(AVE)/p', '(AVE)/p', ];
  push @data_d, [ 'FOOT', '', '', 'Total:', '(SUM)', '(SUM)', '(SUM)', ];
  push @data_s, [ 'FOOT', '', '', 'Total:', map { '(SUM)' } ( 0 .. 6 ), '(SUM)' ];
  
  $side = color_name( $side );
  $text .= "<h3>$side Shots and accuracy</h3>" . html_table( \@data_w ) if $type eq 'SHOTS';
  $text .= "<h3>$side Damage</h3>" . html_table( \@data_d ) if $type eq 'DAMAGE';
  $text .= "<h3>$side Skills</h3>" . html_table( \@data_s ) if $type eq 'SKILLS';
  $text .= "<h3>Detailed Shots and accuracy</h3>" . html_table( \@data_w ) if $type eq 'DETAILS';
  
  return $text;
}

#----------------------------------------------------------------------------

sub mod_skills_stats
{
  my $title = shift;
  my $p = shift; # player
  my %opt = @_;
  
  return undef unless $player{ $p };
  
  my @data_s;
  
  push @data_s, [ 'HEAD', '[>5%]#', 'Skill', '[>10%]Total Score', '[>10%]Median Score', '[>10%]Average Score', '[>20%]Percentage' ];
  
  for my $s ( sort { $player{ $p }{ 'SKILL' }{ $b } <=> $player{ $p }{ 'SKILL' }{ $a } } 0..6 )
    {
    my $ss = $player{ $p }{ 'SKILL' }{ $s }; # skill score
    next if $ss == 0;
    my $sc = $player{ $p }{ 'TOTAL_SCORE' }; # score
    my $pr = $ss > 0 ? ( 100 * $ss ) / $sc : ''; # percentage
    my $sw = lc $SKILL{ $s };
    $sw = $1 if $sw =~ /^([A-Z]+)/i;
    push @data_s, [ '', '(ROW)', "<a href=s_$sw.html>" . $SKILL_IMG{ $s } . " " . $SKILL{ $s } . "</a>", 
                    $ss, 
                    $player{ $p }{ 'MEDIAN_SKILL' }{ $s },
                    $player{ $p }{ 'AVERAGE_SKILL' }{ $s },
                    "$pr/p" ];
    }
  my $tot;
  $tot .= $SKILL_IMG{ $_ } for ( 0..6 );
  push @data_s, [ 'COMT', '', "$tot TOTAL XP", 
                  $player{ $p }{ 'TOTAL_SCORE' },
                  $player{ $p }{ 'MEDIAN_SCORE' },
                  $player{ $p }{ 'AVERAGE_SCORE' },
                  "n/a" ];
  
  push @data_s, [ 'FOOT', '', '[>]Total score:', '(SUM)', '', '', $player{ $p }{ 'TOTAL_SCORE' } ];

  return "<h2>$title</h2>" . html_table( \@data_s );
}

#----------------------------------------------------------------------------

sub mod_skills_usage
{
  my $title = shift;
  my $s = shift; # skill
  my %opt = @_;
  
  my $clan = $opt{ 'CLAN' };
  
  my @data_s;
  
  my @sl;
  for my $s ( 0..6 )
    {
    my $sw = lc $SKILL{ $s };
    $sw = $1 if $sw =~ /^([A-Z]+)/i;
    push @sl, "[>7%]<a href=s_$sw.html>" . $SKILL_IMG{ $s } . "</a>";
    }
  push @data_s, [ 'HEAD', '[>1%]#', '[30%]Player', @sl, '[>12%]SCORE' ];
  
  for my $p ( keys %player )
    {
    next if $clan and $p !~ /^!/;
    next if !$clan and $p =~ /^!/;
    next if $player{ $p }{ 'MEDIAN_SCORE' } < $SCORE_FLOOR;

    my $pc = color_name( $p );
    my @ss;
    push @ss, $player{ $p }{ 'SKILL' }{ $_ } for ( 0..6 );
    push @data_s, [ '', '(ROW)',
                "<a class=t href=p_$href{$p}.html>$pc</a>", 
                @ss,
                $player{ $p }{ 'TOTAL_SCORE' }
                ];
    }
  
  push @data_s, [ 'FOOT', '', 'Total:', map { '(SUM)' } ( 0 .. 6 ), '(SUM)' ];

  return "<h2>$title</h2>" . html_table( \@data_s, SORT => $s + 3 );
}

#----------------------------------------------------------------------------

sub mod_skills_totals
{
  my $title = shift;
  my %opt = @_;
  
  my @data_s;
  
  push @data_s, [ 'HEAD', '[>5%]#', 'Skill', '[>20%]Score' ];
  
  for my $s ( sort { $skills{ $b } <=> $skills{ $a } } keys %skills )
    {
    my $sw = lc $SKILL{ $s };
    $sw = $1 if $sw =~ /^([A-Z]+)/i;
    push @data_s, [ '', '(ROW)', "<a href=s_$sw.html>" . $SKILL_IMG{ $s } . " " . $SKILL{ $s } . "</a>", $skills{ $s } ];
    }
  
  push @data_s, [ 'FOOT', '', '[>]Total score:', '(SUM)' ];

  return "<h2>$title</h2>" . html_table( \@data_s );
}

#----------------------------------------------------------------------------

sub mod_weapons_stats
{
  my $title = shift;
  my $p = shift; # player
  my %opt = @_;
  
  return undef unless $player{ $p };
  
  my @data_w;
  
  push @data_w, [ 'HEAD', '[>5%]#', '[40%]Weapon', '[>]Shots', '[>]Hits', '[>]Head', '[>]Kills', '[>]Deaths', '[>]Acc.%', '[>]HeadAcc.%', ];
  
  for my $w ( sort { $player{ $p }{ 'WEAPONS' }{ $b }{ 'K' } <=> $player{ $p }{ 'WEAPONS' }{ $a }{ 'K' } } keys %{ $player{ $p }{ 'WEAPONS' } } )
    {
    my $wt = $player{ $p }{ 'WEAPONS' }{ $w };
    eval 
      {
      $wt->{ 'HA' } = ( 100 * $wt->{ 'H' } ) / $wt->{ 'S' };
      $wt->{ 'EA' } = ( 100 * $wt->{ 'E' } ) / $wt->{ 'S' };
      };
    my $wn = $WEAPON{ $w };
    my $ww = lc $wn;
    push @data_w, [ '', '(ROW)',
                "<a href=w_$ww.html>$wn</a>",
                $wt->{ 'S' },
                $wt->{ 'H' },
                $wt->{ 'E' },
                "<div class=hitext>" . $wt->{ 'K' } . "</div>",
                $wt->{ 'D' },
                $wt->{ 'HA' } . '/p',
                $wt->{ 'EA' } . '/p',
                ];
    }

  push @data_w, [ 'FOOT', '', 'Total:', '(SUM)', '(SUM)', '(SUM)', '(SUM)', '(SUM)', '(AVE)/p', '(AVE)/p', ];
  
  return "<h2>$title</h2>" . html_table( \@data_w );
}

#----------------------------------------------------------------------------

sub mod_weapons_usage
{
  my $title = shift;
  my $w = shift; # weapon
  my %opt = @_;

  my $clan = $opt{ 'CLAN' };
  
  my $ww = lc $WEAPON{ $w };
  
  my @data_w;
  
  push @data_w, [ 'HEAD', '[>5%]#', '[40%]Player/Clan', "[>]Shots", "[>]Hits", "[>]Head", "[>]Kills", "[>]Deaths", "[>]Acc.%", "[>]HeadAcc.%", ];
  #for my $p ( sort { $player{ $b }{ 'WEAPONS' }{ $w }{ 'K' } <=> $player{ $a }{ 'WEAPONS' }{ $w }{ 'K' } } keys %player )
  for my $p ( keys %player )
    {
    next if $clan and $p !~ /^!/;
    next if !$clan and $p =~ /^!/;
    next if $player{ $p }{ 'MEDIAN_SCORE' } < $SCORE_FLOOR;

    my $wt = $player{ $p }{ 'WEAPONS' }{ $w };
    next if $wt->{ 'S' } == 0;
    eval 
      {
      $wt->{ 'HA' } = ( 100 * $wt->{ 'H' } ) / $wt->{ 'S' };
      $wt->{ 'EA' } = ( 100 * $wt->{ 'E' } ) / $wt->{ 'S' };
      };
    my $pc = color_name( $p );
    push @data_w, [ '', '(ROW)',
                "<a class=t href=p_$href{$p}.html>$pc</a>", 
                $wt->{ 'S' },
                $wt->{ 'H' },
                $wt->{ 'E' },
                $wt->{ 'K' },
                $wt->{ 'D' },
                $wt->{ 'HA' } . '/p',
                $wt->{ 'EA' } . '/p',
                ];
    }
    
  push @data_w, [ 'FOOT', '', 'Total:', '(SUM)', '(SUM)', '(SUM)', '(SUM)', '(SUM)', '(AVE)/p', '(AVE)/p', ];
  
  return "<h2>$title</h2>" . html_table( \@data_w, SORT => $opt{ 'SORT' } );
}

#----------------------------------------------------------------------------

sub mod_weapons_totals
{
  my $title = shift;
  my %opt = @_;
  
  my @data_w;
  
  push @data_w, [ 'HEAD', '[>5%]#', '[40%]Weapon', '[>]Shots', '[>]Hits', '[>]Head', '[>]Kills', '[>]Acc.%', '[>]HeadAcc.%', ];
  
  for my $w ( keys %weapons )
    {
    my $wt = $weapons{ $w };
    eval 
      {
      $wt->{ 'HA' } = ( 100 * $wt->{ 'H' } ) / $wt->{ 'S' };
      $wt->{ 'EA' } = ( 100 * $wt->{ 'E' } ) / $wt->{ 'S' };
      };
    my $wn = $WEAPON{ $w };
    my $ww = lc $wn;
    push @data_w, [ '', '(ROW)',
                "<a href=w_$ww.html>$wn</a>",
                $wt->{ 'S' },
                $wt->{ 'H' },
                $wt->{ 'E' },
                $wt->{ 'K' },
                $wt->{ 'HA' } . '/p',
                $wt->{ 'EA' } . '/p',
                ];
    }

  push @data_w, [ 'FOOT', '', 'Total:', '(SUM)', '(SUM)', '(SUM)', '(SUM)', '(AVE)/p', '(AVE)/p', ];
  
  return "<h2>$title</h2>" . html_table( \@data_w, SORT => $opt{ 'SORT' } );
}

##############################################################################

my %seen_weaponstats = ();
sub parse_weaponstats
{
  my $ws = shift;
  my $game_time = shift; # to skip seen weponstats per game
  # WeaponStats: 
  # 2 1 3145756 0 0 0 1 0 3 14 0 0 0 0 0 0 1 0 0 0 0 1 0 3 8 1 0 1 238 472 0 65 9 5
  my @ws = split /\s+/, $ws;
  
  my %data;
  
  $data{ 'CLIENT' } = shift @ws;
  $data{ 'PLAYER' } = $client{ $data{ 'CLIENT' } }{ 'n' };
  $data{ 'SIDE'   } = $SIDE{ $client{ $data{ 'CLIENT' } }{ 't' } };
  $data{ 'CLASS'  } = $CLASS{ $client{ $data{ 'CLIENT' } }{ 'c' } };
  $data{ 'CARRY' } = shift @ws; # 0 = first round, 1 == carry, i.e. second or next round

  next if $seen_weaponstats{ "$game_time:$ws" }++;
  
  my @wep = reverse split //, sprintf '%b', shift @ws;
  my $wc = -1; # weapon counter
  for( @wep )
    {
    $wc++;
    next unless $_;
    
    $data{ 'WEAPONS' }{ $wc }{ 'H' } = shift @ws;
    $data{ 'WEAPONS' }{ $wc }{ 'S' } = shift @ws;
    $data{ 'WEAPONS' }{ $wc }{ 'K' } = shift @ws;
    $data{ 'WEAPONS' }{ $wc }{ 'D' } = shift @ws;
    $data{ 'WEAPONS' }{ $wc }{ 'E' } = shift @ws;
    eval 
      {
      $data{ 'WEAPONS' }{ $wc }{ 'HA' } = ( 100 * $data{ 'WEAPONS' }{ $wc }{ 'H' } ) / $data{ 'WEAPONS' }{ $wc }{ 'S' };
      $data{ 'WEAPONS' }{ $wc }{ 'EA' } = ( 100 * $data{ 'WEAPONS' }{ $wc }{ 'E' } ) / $data{ 'WEAPONS' }{ $wc }{ 'S' };
      };
    }
  for my $w ( keys %{ $data{ 'WEAPONS' } } )
    {
    for my $a ( qw( S H K D E ) )
      {
      $data{ 'WEAPONS_TOTALS' }{ $a } += $data{ 'WEAPONS' }{ $w }{ $a };
      $player{ $data{ 'PLAYER' } }{ 'WEAPONS' }{ $w }{ $a } += $data{ 'WEAPONS' }{ $w }{ $a };
      ###$player{ get_clan( $data{ 'PLAYER' } ) }{ 'WEAPONS' }{ $w }{ $a } += $data{ 'WEAPONS' }{ $w }{ $a };
      $weapons{ $w }{ $a } += $data{ 'WEAPONS' }{ $w }{ $a };
      }
    }  
  eval 
    {
    $data{ 'WEAPONS_TOTALS' }{ 'HA' } = ( 100 * $data{ 'WEAPONS_TOTALS' }{ 'H' } ) / $data{ 'WEAPONS_TOTALS' }{ 'S' };
    $data{ 'WEAPONS_TOTALS' }{ 'EA' } = ( 100 * $data{ 'WEAPONS_TOTALS' }{ 'E' } ) / $data{ 'WEAPONS_TOTALS' }{ 'S' };
    };
  $data{ 'DAMAGE' }{ 'SENT' } = shift @ws;  
  $data{ 'DAMAGE' }{ 'RECV' } = shift @ws;  
  $data{ 'DAMAGE' }{ 'TEAM' } = shift @ws;  
  
  my @ski = split //, sprintf '%b', shift @ws;
  my $sc = -1; # skill counter
  for( @ski )
    {
    $sc++;
    next unless $_;
    $data{ 'SKILL' }{ $sc } = shift @ws; # each skill for this game (xp)
    $data{ 'SCORE' } += $data{ 'SKILL' }{ $sc }; # score for this game (xp sum)
    
    # player totals
    #$player{ $data{ 'PLAYER' } }{ 'SKILL' }{ $sc } += $data{ 'SKILL' }{ $sc };
    #$player{ $data{ 'PLAYER' } }{ 'TOTAL_SCORE' } += $data{ 'SKILL' }{ $sc };
    
    ###$player{ get_clan( $data{ 'PLAYER' } ) }{ 'SKILL' }{ $sc } += $data{ 'SKILL' }{ $sc };
    ###$player{ get_clan( $data{ 'PLAYER' } ) }{ 'SCORE' } += $data{ 'SKILL' }{ $sc };
    
    # skill totals
    $skills{ $sc } += $data{ 'SKILL' }{ $sc };
    
    # collect median skills
    $player{ $data{ 'PLAYER' } }{ 'SKILL_TMP' }{ $sc } = []
        unless $player{ $data{ 'PLAYER' } }{ 'SKILL_TMP' }{ $sc };
    push @{ $player{ $data{ 'PLAYER' } }{ 'SKILL_TMP' }{ $sc } }, $data{ 'SKILL' }{ $sc };
    }
  # collect median scores
  $player{ $data{ 'PLAYER' } }{ 'SCORE_TMP' } = []
      unless $player{ $data{ 'PLAYER' } }{ 'SCORE_TMP' };
  push @{ $player{ $data{ 'PLAYER' } }{ 'SCORE_TMP' } }, $data{ 'SCORE' };

  # print ">>>>>>>>>>> $data{ 'PLAYER' }: @{ $player{ $data{ 'PLAYER' } }{ 'SCORE_TMP' } }\n";
  return $data{ 'SCORE' } > 0 ? \%data : undef; # ako nqma tochki, ne e igral :)
}

#----------------------------------------------------------------------------

sub mod_hash_stats
{
  my $title = shift;
  my $hr    = shift;
  my %opt   = @_;
  my $text;

  my $clan = $opt{ 'CLAN' };
  my $tfmt = $opt{ 'TIMEFMT' };
  my $head = $opt{ 'HEAD' };
  
  my $sum = hash_sum( $hr );
  
  my @data;
  
  $text .= "<p>";
  $text .= "<h2>$title</h2>";
  
  push @data, [ 'OPT', "width=05% align=right", "width=40%", "width=30% align=right", "width=25% align=right" ];
  if( $head )
    {
    push @data, [ 'HEAD', split /\s*,\s*/, $head ];
    }
  else
    {  
    push @data, [ 'HEAD', "#", "Name", "Value", "Percentage" ];
    }
  
  my $row = 0;
  for my $k ( sort { $hr->{ $b } <=> $hr->{ $a } } keys %$hr )
    {
    next if $clan and $k !~ /^!/;
    next if !$clan and $k =~ /^!/;
    
    my $v = $hr->{ $k };
    my $p = $sum > 0 ? sprintf "%.2f%%", 100 * $v / $sum : 'n/a'; # '
    
    if( $href{ $k } )
      {
      $k = "<a class=t href=p_$href{$k}.html>".color_name( $k )."</a>";
      }
    else
      {
      $k = color_name( $k );
      }  
    
    $p = 'n/a' if $opt{ 'NOP' };
      
    if ( $row < $FLOOR )
      {
      $row++;
      my $class = tr_class();
      $v = time_fmt( $v ) if $tfmt;
      push @data, [ '', '(ROW)', $k, $v, $p ];
      }        
    }
  $sum = time_fmt( $sum ) if $tfmt;
  if( $opt{ 'NOP' } )
    {
    pop( @$_ ) for ( @data );
    }
  else
    {  
    push @data, [ 'FOOT', '', 'Total:', $sum, '' ];
    }
  $text .= html_table( \@data );
  $text .= "\n\n\n\n";
  return $text;
}

#----------------------------------------------------------------------------

sub mod_kill_killed
{
  my $title = shift;
  my $p = shift; # player
  my %opt = @_;
  
  my @data;
  push @data, [ 'HEAD', "[>5%]#", "[25%]Killed:", "[>10%]Times", "[>10%]%",
                        "[>5%]#", "[25%]Killed by:", "[>10%]Times", "[>10%]%" ];

  my @killed = sort { $kil2{ $p }{ $b } <=> $kil2{ $p }{ $a } } keys %{ $kil2{ $p } };
  my @killby = sort { $ded2{ $p }{ $b } <=> $ded2{ $p }{ $a } } keys %{ $ded2{ $p } };
  
  my $sum_k = hash_sum( $kil2{ $p } );
  my $sum_d = hash_sum( $ded2{ $p } );
  
  my $c = 0;
  while(4)
    {
    my $k = shift @killed;
    my $d = shift @killby;
    
    my $kv = $kil2{ $p }{ $k };
    my $dv = $ded2{ $p }{ $d };
    
    my $kp = $sum_k > 0 ? ( 100 * $kv ) / $sum_k : 0;
    my $dp = $sum_d > 0 ? ( 100 * $dv ) / $sum_d : 0;
    
    my $kc = color_name( $k );
    my $dc = color_name( $d );
    
    push @data, [ '', '(ROW)', "<a class=t href=p_$href{$k}.html>$kc</a>", $kv, "$kp/p",
                      '(ROW)', "<a class=t href=p_$href{$d}.html>$dc</a>", $dv, "$dp/p" ];
    
    last unless @killed or @killby;
    last if ++$c == $FLOOR;
    }
    
  push @data, [ 'FOOT', '', '[>]Total:', '(SUM)', '',
                        '', '[>]Total:', '(SUM)', '' ];
  
  return "<h2>$title</h2>" . html_table( \@data );
}

#----------------------------------------------------------------------------

sub html_table_cmp
{
  my $aa = shift;
  my $bb = shift;
  my $ta = shift;
  my $tb = shift;
  
  return -1 if $ta eq 'HEAD';
  return  1 if $tb eq 'HEAD';
  return  1 if $ta eq 'FOOT';
  return -1 if $tb eq 'FOOT';
  
  $aa = $3 if $aa =~ /^(\[([^\]]+)\])?(.+)(\/([ip]))?$/o;
  $bb = $3 if $bb =~ /^(\[([^\]]+)\])?(.+)(\/([ip]))?$/o;
  
  return $bb <=> $aa;
}

sub html_table
{
  my $ar = shift;
  my %opt = @_;
  
  my $text;
  $text .= "<table width=80% cellspacing=1 cellpadding=5>\n";
  my @or; # options row
  my $r = -1; # row
  
  my @ar = @$ar;
  
  my $floor = $opt{ 'FLOOR' } || $FLOOR;
  
  my $oc = $opt{ 'SORT' }; # sort/order column
  @ar = sort { html_table_cmp( $a->[$oc], $b->[$oc], $a->[0], $b->[0] ) } @ar if $oc > 0;
  
  for my $rr ( @ar )
    {
    $r++ if $rr->[0] eq '';
    if( $floor > 0 )
      {
      next if $rr->[0] eq 'COMT' and $r >= $floor;
      next if $rr->[0] eq ''     and $r >= $floor;
      }
    my $c = -1; # column
    my $class = tr_class( $r );
    @or = @$rr and next if $rr->[0] eq 'OPT';
    $class = 'hh' if $rr->[0] eq 'HEAD'; # header
    $class = 'ff' if $rr->[0] eq 'FOOT'; # footer
    $class = 'cc' if $rr->[0] eq 'COMT'; # comments
    $text .= "<tr class=$class>\n";
    for( @$rr )
      {
      my $d = $_;
      $c++;
      next if $c == 0;
      
      if( $d =~ s/^\[([^\]]+)\]// )
        {
        my $p = $1; # params
        my $o; # opts
        $o .= " align=right" if $p =~ />/;
        $o .= " width=$1" if $p =~ /(\d+%)/;
        $or[$c] = $o;
        #print STDERR "TABLE OPT: $p --> $o\n";
        #$text .= "TABLE OPT: $p --> $o<br>";
        }
      my $f = lc $1 if $d =~ s/\/([ip])$//; # [i]nt, [p]ercent
      $d = table_sum( $ar, $c ) if $d eq '(SUM)';
      $d = table_ave( $ar, $c ) if $d eq '(AVE)';
      $d = table_med( $ar, $c ) if $d eq '(MED)';
      
      $d = int $d if $f eq 'i';
      $d = $d > 0 ? sprintf "%.2f%%", $d : '' if $f eq 'p';
      
      $d = $r + 1 if $d eq '(ROW)';
      $d = "<div class=hitext>$d</div>" if $oc > 1 and $c == $oc and ! $$rr[0];
      $text .= "<td $or[$c]>$d</td>";
      }
    $text .= "</tr>\n";
    }
  $text .= "</table>\n";
  return $text;
}

sub table_sum
{
  my $ar = shift;
  my $col = shift;
  my $sum = 0;
  for my $rr ( @$ar )
    {
    next if $rr->[0] ne ''; # skip HEAD,FOOT
    $sum += $rr->[$col];
    }
  return $sum;
}

sub table_ave
{
  my $ar = shift;
  my $col = shift;
  my $sum = 0;
  my $cnt = 0;
  for my $rr ( @$ar )
    {
    next if $rr->[0] ne ''; # skip HEAD,FOOT
    $sum += $rr->[$col];
    $cnt++;
    }
  return $cnt > 0 ? $sum / $cnt : 0;
}

sub table_med
{
  my $ar = shift;
  my $col = shift;
  my @sum;
  for my $rr ( @$ar )
    {
    next if $rr->[0] ne ''; # skip HEAD,FOOT
    push @sum, $rr->[$col];
    }
  @sum = sort { $b <=> $a } @sum;  
  return $sum[ @sum / 2 ];
}

##############################################################################

sub time_fmt
{
  my $data = shift;
  my $d = int($data / (24*60*60));
  my $h = int(($data % (24*60*60)) / (60*60));
  my $m = int(($data % (60*60)) / 60);        
  my $s = $data % 60;                 
  return sprintf "%6dd %02dh %02dm %02ds", $d, $h, $m, $s;
}

sub html_save
{
  my $file = shift;
  $file = "$html_dir/$file.html";
  open(my $o, '>' . $file) or die "$0: cannot save html file: $file\n";
  my $text = join '', $html_header, @_, $html_footer;
  my $time = scalar localtime();
  $text =~ s/\[TIME\]/$time/g;
  $text =~ s/\[ENV:([^\]]+)\]/$ENV{$1}/g;
  print $o $text;
  close($o);
  print STDERR "file $file written ok\n";
}

sub color_name
{
  my $s = shift;
  my $cs = $nam_color{ $s } || $s;
  # return $s unless $cs;
  my $c = $cs =~ s/\^(.)/"<font color=#" . $COLOR{ lc $1 } . ">"/gie;
  $cs .= "</font>" x $c;
  return "<font color=#ffffff>$cs</font>";
}

sub tr_class
{
  $_[0] % 2 ? 'r1' : 'r2';
}

sub hash_max
{
  my $hr = shift;
  my $max_k = undef;
  my $max_v = undef;
  while( my ( $k, $v ) = each %$hr )
    {
    if( $max_v eq '' or $v > $max_v )
      {
      $max_k = $k;
      $max_v = $v;
      next;
      }
    }
  #print STDERR "$max_k, $max_v\n";
  return ( $max_k, $max_v );
}

sub hash_sum
{
  my $hr = shift;
  my $sum = 0;
  while( my ( $k, $v ) = each %$hr )
    {
    next if $k =~ /^!/;
    $sum += $v;
    }
  return $sum;
}

sub get_clan
{
  my $s = shift;
  my $c = '';
  $c = $1 if $s =~ /^\[([^\]]+)\]/;
  $c = $1 if $s =~ /\[([^\]]+)\]$/;
  $c = $1 if $s =~ /^([A-Z]{2,3})[:\-\|]/i;
  return uc "!$c";
}

###TEST#######################################################################

=pod

Axis   HELLS BELLS       0   1   0  0   0   0     0   125    0      0
                       4 0   1   0  0   0   1    0 0  125    0      0 
                       
Allies ValBo             2   4   0  1  33  17   360   800   66     31                       
                       0 1 133657 0 8 0 0 0 6 9 1 0 0 14 28 1 0 0 0 2 0 0 0 0 4 0 0 0 0 0 0 4 0 360 800 66 19 8 20 3

+++++++++
WS WeaponStats: 2 1 3145756 0 0 0 1 0 3 14 0 0 0 0 0 0 1 0 0 0 0 1 0 3 8 1 0 1 238 472 0 65 9 5                       
Axis   [LUD]CADE   1   3   0  0  25   0   238   472    0     14 
               WS 2 1 
               3145756 (1100000000000000011100)
                         0  0 0 1 0 
                         3 14 0 0 0 
                         0  0 0 1 0 
                         0  0 0 1 0 
                 MP-40   3  8 1 0 1 
                 
                 238 472 0 
                 65 9 5                       
                 
Weapon     Acrcy Hits/Atts Kills Deaths Headshots
-------------------------------------------------
Colt     :                     0      1         0
MP-40    :  21.4    3/14       0      0         0
Thompson :                     0      1         0
Garand   :                     0      1         0
K43 Rifle:  37.5    3/8        1      0         1

Damage Given: 238     Team Damage: 0
Damage Recvd: 472

Rank: Schutze (14 XP)
Skills         Level/Points
---------------------------
Battle Sense   0 (9/20)
Covert Ops     0 (5/20)
                 
------------------------------------------------------------------------------

tova e po-skoro tehnicheska tema taka che ako na nqkoi ne mu e interesno da q 
propusne oshte sega

mai uspqh da razbera kakvo oznachava WeaponStats ot log-a, bih iskal da go 
post-na tuk v sluchai
che na nqkoi mu potrqbva ili mu e interesno

ta v loga nakraq na vsqka igra se poqvqva tova (t.e. podobni redove ):

WeaponStats: 2 1 3145756 0 0 0 1 0 3 14 0 0 0 0 0 0 1 0 0 0 0 1 0 3 8 1 0 1 238 472 0 65 9 5

i sega edno po edno:

2 -- nomer na client-a (player)
1 -- tova mai e za kolko rounds sa tezi danni
3145756 -- bitmap s izpolzvanite oryjiq (binarno e: 1100000000000000011100) t.e. 
           izpolzvani sa 5 oryjiq (colt,mp40,thompson,garand,k43) sledvat grupi 
           ot po 5 chisla za vsqko polzvano oryjie i 
           oznachavat: hits, shots, kills, deaths, headshots

t.e. gornite chisla predstavlqvat tova:

Weapon Acrcy Hits/Atts Kills Deaths Headshots
-------------------------------------------------
Colt : 0 1 0
MP-40 : 21.4 3/14 0 0 0
Thompson : 0 1 0
Garand : 0 1 0
K43 Rifle: 37.5 3/8 1 0 1

sledvashtite 3 chisla sa:

Damage Given: 238
Damage Recvd: 472
Team Damage: 0

sled tova pak ima bitmap na izpolzvanite abilities (clasove)
65 -- binarno e 1000001 i levelite za tezi abilities:

Skills Level/Points
---------------------------
Battle Sense 0 (9/20)
Covert Ops 0 (5/20)

Rank-a mai samo se sybira, t.e. e 14

voila

btw: thanx na Lg-Badluck che mi obyrna vnimanie na komandata /statsdump!

cheers! 


=cut

###EOF########################################################################

